﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Heranca_exerc2
{
    class Program
    {
        public class animal
        {
            public string nome { get; set; }
            public string classificacao { get; set; }

            public void lerdados()
            {
               Console.Write("Digite o nome do animal: ");
               this.nome = Console.ReadLine();
               Console.Write("Digite a classificacao {0}: ",this.nome);
               this.classificacao = Console.ReadLine();
            }

            public void mostrardados()
            {
                Console.WriteLine("Nome do animal: {0}", this.nome);
                Console.WriteLine("Classificação do animal: {0}", this.classificacao);
            }

            public virtual void emitirsom()
            {
                Console.WriteLine("{0} emitiu o som", this.nome);
            }
        }

        public class cachorro : animal
        {
            public override void emitirsom()
            {
                Console.WriteLine("{0} fez AU AU", this.nome);
            }
        }

        public class gato : animal 
        {
            public override void emitirsom()
            {
                Console.WriteLine("{0} fez MIAU MIAU", this.nome);
            }
        }

        public class galinha : animal
        {
            public override void emitirsom()
            {
                Console.WriteLine("{0} fez CÓ CÓ", this.nome);
            }
        }

        
        static void Main(string[] args)
        {
            cachorro teste1 = new cachorro();
            gato teste2 = new gato();
            galinha teste3 = new galinha();

            string opcao = "";
            
            do
            {
                Console.Clear();
                Console.WriteLine("\t1 - Criar cachorro");
                Console.WriteLine("\t2 - Criar gato");
                Console.WriteLine("\t3 - Criar galinha");
                Console.WriteLine("\t4 - EmitirSom cachorro");
                Console.WriteLine("\t5 - EmitirSom gato");
                Console.WriteLine("\t6 - EmitirSom galinha");
                Console.WriteLine("\t7 - Mostrar todos animais");
                Console.WriteLine("\t8 - Sair");
                Console.Write("Qual opção? ");
                opcao = Console.ReadLine();

                switch (opcao)
                {
                    case "1":
                        teste1.lerdados();
                        break;
                    case "2":
                        teste2.lerdados();
                        break;
                    case "3":
                        teste3.lerdados();
                        break;
                    case "4":
                        if (teste1.nome != null)
                            teste1.emitirsom();
                        else
                            Console.WriteLine("Crie o cachorro primeiro!");
                        break;
                    case "5":
                        if (teste2.nome != null)
                            teste2.emitirsom();
                        else
                            Console.WriteLine("Crie o gato primeiro!");
                        break;
                    case "6":
                        if (teste3.nome != null)
                            teste3.emitirsom();
                        else
                            Console.WriteLine("Crie a gaalinha primeiro!");
                        break;
                    case "7":
                        if (teste1.nome != null)
                            teste1.mostrardados();
                        else
                            Console.WriteLine("O cachorro não foi criado!");
                        if (teste2.nome != null)
                            teste2.mostrardados();
                        else
                            Console.WriteLine("O gato não foi criado!");
                        if (teste3.nome != null)
                            teste3.mostrardados();
                        else
                            Console.WriteLine("A galinha não foi criado!");
                        break;
                    case "8":
                        Console.WriteLine("\t\tSaindo...");
                        break;
                    default:
                        Console.WriteLine("Opção Inválida");
                        break;

                }
                Console.WriteLine("Pressione qualquer tecla para continuar...");
                Console.ReadKey();

            } while (opcao != "8");
        }
        
    }
}
